package org.example;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.Semaphore;
import java.util.concurrent.atomic.AtomicInteger;

public class Main {
    public static void main(String[] args) {
        Queue<Integer> pool = new ConcurrentLinkedQueue<>();
        for (int i = 0; i < 400; i++) {
            pool.add(i);
        }
        CountDownLatch latch = new CountDownLatch(10000);
        Semaphore semaphore = new Semaphore(400);
        Map<Integer, Integer> map = new HashMap<>();
        Map<Integer, AtomicInteger> map2 = new HashMap<>();
        for (int i = 0; i < 400; i++) {
            map.put(i, getNum(i));
            map2.put(i, new AtomicInteger(0));
        }
        for (int i = 0; i < 10000; i++) {
            try {
                semaphore.acquire();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            new Thread(new Runnable() {
                public void run() {
                    int count = 0, over = 0;
                    while (count++ < 400) {
                        Integer poll = pool.poll();
//                        if (poll == null) System.out.println("null");
//                        synchronized (Objects.requireNonNull(poll)) {
                            if (checkNum(poll)) {
//                            System.out.println(Thread.currentThread().getName() + ": "+poll);
                                pool.add(poll);
                                latch.countDown();
                                map2.get(poll).incrementAndGet();
                                over = 1;
                                break;
                            } else {
                                pool.add(poll);
//                            }
                        }
                    }
                    if (over == 0) {
                        System.out.println("over");
                        latch.countDown();
                    }
                    semaphore.release();
                }

                private boolean checkNum(Integer poll) {
                    try {
                        Thread.sleep(2000);
                        if (map2.get(poll).get() < map.get(poll)) {
                            return true;
                        }
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                    return false;
                }
            }).start();
        }
        try {
            latch.await();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        System.out.println("Hello world!");
        System.out.println(map2);
        System.out.println(map);
    }

    private static Integer getNum(int i) {
        if (i % 2 == 0) {
            return 40;
        } else {
            return 10;
        }
    }
}